// Written By:	David Hicken
// Date:		March 2004
// Purpose:		Opens a list of files previously specified by SaveSession
//
// License:
//     This homesite script is freely available to all, to use, to modify, to redistribute
// however you like as long as you leave my name at the top as the original creator.  I will
// not be held liable for any repercussions anyone experiences from using this script.
//

// constants for prompts
var hsOK = 0;
var hsYesNoCancel = 3;
var hsYesNo = 4;
var hsQuestion = 32;
var hsExclamation = 48;
var hsInfo = 64;
// button values
var hsOKValue = 1;
var hsCancel = 2;
var hsAbort = 3;
var hsRetry = 4;
var hsIgnore = 5;
var hsYes = 6;
var hsNo = 7;

var app = Application;
var findex = app.DocumentIndex;
var doccount = app.DocumentCount;
var sessionfile = '';
var fname = app.ActiveDocument.Filename;

function Main() {
	var openwith = hsNo;
	if (doccount > 1 || (doccount == 1 && fname != '')){
		openwith = app.MessageBox("Opening Saved Session\n\nLeave Current Files Open?", "Load Session", hsYesNo + hsQuestion);
		if (openwith == hsNo) app.CloseAll(true);
	}
	doccount = app.DocumentCount;
	fname = app.ActiveDocument.Filename;
	if ((doccount == 1 && fname == '') || openwith == hsYes) {
		var opened = app.OpenFile(sessionfile);
		if (opened){
			var linecount = app.ActiveDocument.LineCount;
			if (linecount > 1){
				var sindex = app.DocumentIndex;
				var sparts = new Array();
				var sline = '';
				sline = app.ActiveDocument.Lines(0);
				sparts = sline.split("\|");
				if (sparts[0] == 'Homesite Save Session') {
					var gotoindex = parseInt(sparts[1]);
					if (gotoindex < 0) gotoindex = 0;
					if (openwith == hsYes) gotoindex = findex + 1;
					var failedtoopen = '';
					var lines = new Array();
					for (i=1; i < linecount; i++){
						lines[i] = app.ActiveDocument.Lines(i);
					}
					for (i=1; i < linecount; i++){
						if (lines[i]) {
							var cline = lines[i];
							var cparts = new Array();
							cparts = cline.split("\|");
							if (cparts[0] != ''){
								var copened = app.OpenFile(cparts[0]);
								if (copened) {
									var csparts = new Array();
									var cix = 0;
									var ciy = 0;
									csparts = cparts[1].split(",");
									cix = parseInt(csparts[0]);
									ciy = parseInt(csparts[1]);
									app.ActiveDocument.GetCaretPos(cix, ciy);
								} else {
									failedtoopen = failedtoopen + cparts[0] + "\n";
									if (openwith == hsNo && (i - 1) == gotoindex) gotoindex = 0;
								}
							}
						}
					}
					app.DocumentIndex = sindex;
					app.ActiveDocument.Close(false);
					doccount = app.DocumentCount;
					if (gotoindex >= doccount) gotoindex = doccount - 1;
					app.DocumentIndex = gotoindex;
					if (failedtoopen != '') app.MessageBox("Failed To Open The Following:\n" + failedtoopen, "Load Session", hsOK + hsExclamation);
				} else {
					app.ActiveDocument.Close(false);
					app.MessageBox("Session File Invalid", "Load Session", hsOK + hsExclamation);
				}
			} else {
				app.ActiveDocument.Close(false);
				app.MessageBox("Session File Invalid", "Load Session", hsOK + hsExclamation);
			}
		} else {
			app.MessageBox("Failed To Open Session", "Load Session", hsOK + hsExclamation);
		}
	}
}
