// Written By:	David Hicken
// Date:		March 2004
// Purpose:		Saves a list of open files and which file you were working on, so you can close
//				the files, work on something else, then come right back to where you were.  You
//				choose the filename and location of this session file.
//
// License:
//     This homesite script is freely available to all, to use, to modify, to redistribute
// however you like as long as you leave my name at the top as the original creator.  I will
// not be held liable for any repercussions anyone experiences from using this script.
//

// constants for prompts
var hsOK = 0;
var hsYesNoCancel = 3;
var hsYesNo = 4;
var hsQuestion = 32;
var hsExclamation = 48;
var hsInfo = 64;
// button values
var hsOKValue = 1;
var hsCancel = 2;
var hsAbort = 3;
var hsRetry = 4;
var hsIgnore = 5;
var hsYes = 6;
var hsNo = 7;

var app = Application;
var findex = app.DocumentIndex;
var doccount = app.DocumentCount;
var names = 'Homesite Save Session|' + findex + "\n";
var savefile = ''; // blank file name causes save as to prompt user for save file

function Main() {
	if (doccount > 0) {
		var save = hsNo;
		save = app.MessageBox("Would you like to save this sessions list of files?", "Save Session", hsYesNo + hsQuestion);
		if (save == hsYes) {
			app.SaveAll();
			for (i=0; i < doccount; i++){
				var posx = 0;
				var posy = 0;
				app.DocumentIndex = i;
				var nname = app.ActiveDocument.Filename;
				app.ActiveDocument.GetCaretPos(posx, posy);
				names = names + nname + "|" + posx + "," + posy + "\n";
			}
			app.NewDocument(true);
			app.ActiveDocument.Text = names;
			app.MessageBox("You will now be prompted to choose a file to save your session info to.", "Save Session", hsOK + hsInfo);
			var saved = app.ActiveDocument.SaveAs(savefile);
			app.ActiveDocument.Close(false);
			app.DocumentIndex = findex;
			if (!saved){
				app.MessageBox("Failed to save the session, please try again.", "Save Session", hsOK + hsExclamation);
			}
		}
	} else {
		app.MessageBox("No files are open, Save Session would not be saving any info.", "Save Session", hsOK + hsExlamation);
	}
}
